using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace ControlLed
{
	/// <summary>
	/// Description rsume de Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;

		private System.Windows.Forms.MainMenu mainMenu1;

		[Flags]
		public enum LedFlags : int 
		{
			STATE_OFF   = 0x0000,  /* LED teinte */
			STATE_ON    = 0x0001,  /* LED allume */
			STATE_BLINK = 0x0002,  /* LED clignotante */
		}

		public const Int32 NLED_COUNT_INFO_ID    = 0;
		public const Int32 NLED_SUPPORTS_INFO_ID = 1;
		public const Int32 NLED_SETTINGS_INFO_ID = 2;

		public class NLED_COUNT_INFO
		{
			public UInt32 cLeds;
		}

		public class NLED_SUPPORTS_INFO 
		{
			public UInt32 Lednum;
			public Int32 lCycleAdjust;
			public bool fAdjustTotalCycleTime;
			public bool fAdjustOnTime;
			public bool fAdjustOffTime;
			public bool fMetaCycleOn;
			public bool fMetaCycleOff; 
		};

		public class NLED_SETTINGS_INFO
		{
			public UInt32 LedNum;
			public LedFlags OnOffBlink;
			public Int32 TotalCycleTime;
			public Int32 OnTime;
			public Int32 OffTime;
			public Int32 MetaCycleOn;
			public Int32 MetaCycleoff;
		};
         
		[DllImport("CoreDll")]
		private extern static bool NLedGetDeviceInfo( Int32 nID, NLED_COUNT_INFO nci);

		[DllImport("CoreDll")]
		private extern static bool NLedGetDeviceInfo( Int32 nID, NLED_SUPPORTS_INFO nsi);

		[DllImport("CoreDll")]
		private extern static bool NLedGetDeviceInfo( Int32 nID, NLED_SETTINGS_INFO nsi);

		[DllImport("CoreDll")]
		private extern static bool NLedSetDevice( Int32 nID, NLED_SETTINGS_INFO nsi);

		// Retourne le nombre de LED de votre Pocket PC
		// Par dfaut : 1 LED donc index 0
		public static uint GetLedCount()
		{
			NLED_COUNT_INFO nci = new NLED_COUNT_INFO();

			uint LedCount = 0;

			if (NLedGetDeviceInfo(NLED_COUNT_INFO_ID, nci))
				LedCount = nci.cLeds;

			return LedCount;
		}

		// Active le status de la LED
		public static bool SetLedStatus( uint nLed, LedFlags fState)
		{
			NLED_SETTINGS_INFO nsi = new NLED_SETTINGS_INFO();

			nsi.LedNum = nLed;
			nsi.OnOffBlink = fState;

			return NLedSetDevice( NLED_SETTINGS_INFO_ID, nsi);
		}

		public Form1()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//
		}
		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(72, 80);
			this.button1.Text = "Clignoter";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(72, 32);
			this.button2.Text = "Allumer";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(72, 128);
			this.button3.Text = "Stop";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// Form1
			// 
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Menu = this.mainMenu1;
			this.Text = "Form1";

		}
		#endregion

		/// <summary>
		/// Point d'entre principal de l'application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			// On fait clignoter la LED
			SetLedStatus(0, LedFlags.STATE_BLINK);
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			// On allume la LED
			SetLedStatus(0, LedFlags.STATE_ON);
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			// On teint la LED
			SetLedStatus(0, LedFlags.STATE_OFF);
		}
	}
}
